cmake_minimum_required(VERSION 3.8)
project(les_pkg)

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

# find dependencies
find_package(ament_cmake REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rclcpp_action REQUIRED)   # nodig als er een actionserver node wordt gemaakt
find_package(std_msgs REQUIRED)        # gebruik maken von standaard messages
find_package(geometry_msgs REQUIRED)        # gebruik maken von standaard messages
find_package(les_interface REQUIRED)        # gebruik maken von standaard messages

add_executable(les1_clock src/les1/clock.cpp)
add_executable(les1_publisher src/les1/publisher.cpp)
add_executable(les1_subscriber src/les1/subscriber.cpp)

add_executable(les2_service src/les2/service_server.cpp)
add_executable(les2_service_client src/les2/service_client.cpp)

add_executable(les3_action_server src/les3/action_server.cpp)
add_executable(les3_action_client src/les3/action_client.cpp)

ament_target_dependencies(les1_clock rclcpp)
ament_target_dependencies(les1_publisher rclcpp std_msgs geometry_msgs les_interface)
ament_target_dependencies(les1_subscriber rclcpp std_msgs geometry_msgs les_interface)

ament_target_dependencies(les2_service rclcpp les_interface)
ament_target_dependencies(les2_service_client rclcpp les_interface)

ament_target_dependencies(les3_action_server rclcpp rclcpp_action les_interface)
ament_target_dependencies(les3_action_client rclcpp rclcpp_action les_interface)

install (
  TARGETS
    les1_clock
    les1_publisher
    les1_subscriber
    les2_service
    les2_service_client
    les3_action_server
    les3_action_client
  DESTINATION lib/${PROJECT_NAME}
)



if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  # the following line skips the linter which checks for copyrights
  # comment the line when a copyright and license is added to all source files
  set(ament_cmake_copyright_FOUND TRUE)
  # the following line skips cpplint (only works in a git repo)
  # comment the line when this package is in a git repo and when
  # a copyright and license is added to all source files
  set(ament_cmake_cpplint_FOUND TRUE)
  ament_lint_auto_find_test_dependencies()
endif()

ament_package()
